Tonyu.klass.define({
  fullName: 'user.Board',
  shortName: 'Board',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Board_main() {
        "use strict";
        var _this=this;
        
      },
      fiber$main :function _trc_Board_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.retVal=_this;return;
      },
      initialize :function _trc_Board_initialize(o) {
        "use strict";
        var _this=this;
        var y;
        
        __superClass.apply( _this, [o]);
        _this.w=6;
        _this.h=6;
        _this.dices=[];
        y = 0;
        for (; y<_this.h ; y++) {
          Tonyu.checkLoop();
          {
            _this.dices.push([]);
          }
        }
        _this.highLightCol=- 1;
        _this.highLightRow=- 1;
        _this.zOrder=- 1;
      },
      draw :function _trc_Board_draw(ctx) {
        "use strict";
        var _this=this;
        var x;
        var y;
        
        if (_this.highLightCol>=0) {
          x = _this.getLeft()+_this.highLightCol*64;
          
          ctx.fillStyle="rgba(255,255,0,0.5)";
          ctx.fillRect(x,0,64,Tonyu.globals.$screenHeight);
          
        }
        if (_this.highLightRow>=0) {
          y = _this.getTop()+_this.highLightRow*64;
          
          ctx.fillStyle="rgba(0,255,255,0.5)";
          ctx.fillRect(0,y,Tonyu.globals.$screenWidth,64);
          
        }
      },
      Init :function _trc_Board_Init() {
        "use strict";
        var _this=this;
        var y;
        var x;
        
        y = 0;
        for (; y<_this.h ; y++) {
          Tonyu.checkLoop();
          {
            x = 0;
            for (; x<_this.w ; x++) {
              Tonyu.checkLoop();
              {
                _this.dices[y][x]=_this.newDice(x,y,_this.rnd(6)+1);
              }
            }
          }
        }
      },
      fiber$Init :function _trc_Board_f_Init(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var y;
        var x;
        
        y = 0;
        for (; y<_this.h ; y++) {
          Tonyu.checkLoop();
          {
            x = 0;
            for (; x<_this.w ; x++) {
              Tonyu.checkLoop();
              {
                _this.dices[y][x]=_this.newDice(x,y,_this.rnd(6)+1);
              }
            }
          }
        }
        
        _thread.retVal=_this;return;
      },
      getTop :function _trc_Board_getTop() {
        "use strict";
        var _this=this;
        
        return _this.y-_this.h*64/2;
      },
      fiber$getTop :function _trc_Board_f_getTop(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=_this.y-_this.h*64/2;return;
        
        
        _thread.retVal=_this;return;
      },
      getLeft :function _trc_Board_getLeft() {
        "use strict";
        var _this=this;
        
        return _this.x-_this.w*64/2;
      },
      fiber$getLeft :function _trc_Board_f_getLeft(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=_this.x-_this.w*64/2;return;
        
        
        _thread.retVal=_this;return;
      },
      SetHighLightFromX :function _trc_Board_SetHighLightFromX(mx) {
        "use strict";
        var _this=this;
        
        _this.highLightCol=_this.getCol(mx);
      },
      fiber$SetHighLightFromX :function _trc_Board_f_SetHighLightFromX(_thread,mx) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.enter(function _trc_Board_ent_SetHighLightFromX(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$getCol(_thread, mx);
              __pc=1;return;
            case 1:
              _this.highLightCol=_thread.retVal;
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      SetHighLightFromY :function _trc_Board_SetHighLightFromY(my) {
        "use strict";
        var _this=this;
        
        _this.highLightRow=_this.getRow(my);
      },
      fiber$SetHighLightFromY :function _trc_Board_f_SetHighLightFromY(_thread,my) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.enter(function _trc_Board_ent_SetHighLightFromY(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$getRow(_thread, my);
              __pc=1;return;
            case 1:
              _this.highLightRow=_thread.retVal;
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      getCol :function _trc_Board_getCol(mx) {
        "use strict";
        var _this=this;
        var left;
        var i;
        
        left = _this.getLeft();
        
        i = 0;
        for (; i<_this.w ; i++) {
          Tonyu.checkLoop();
          {
            if (mx>=left+64*i&&mx<=left+64*(i+1)) {
              return i;
            }
          }
        }
        return - 1;
      },
      fiber$getCol :function _trc_Board_f_getCol(_thread,mx) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var left;
        var i;
        
        
        _thread.enter(function _trc_Board_ent_getCol(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$getLeft(_thread);
              __pc=1;return;
            case 1:
              left=_thread.retVal;
              
              i = 0;
              
            case 2:
              if (!(i<_this.w)) { __pc=5     ; break; }
              if (!(mx>=left+64*i&&mx<=left+64*(i+1))) { __pc=3     ; break; }
              _thread.exit(i);return;
            case 3     :
              
            case 4     :
              i++;
              __pc=2;break;
            case 5     :
              
              _thread.exit(- 1);return;
              _thread.exit(_this);return;
            }
          }
        });
      },
      getRow :function _trc_Board_getRow(my) {
        "use strict";
        var _this=this;
        var top;
        var i;
        
        top = _this.getTop();
        
        i = 0;
        for (; i<_this.h ; i++) {
          Tonyu.checkLoop();
          {
            if (my>=top+64*i&&my<=top+64*(i+1)) {
              return i;
            }
          }
        }
        return - 1;
      },
      fiber$getRow :function _trc_Board_f_getRow(_thread,my) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var top;
        var i;
        
        
        _thread.enter(function _trc_Board_ent_getRow(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$getTop(_thread);
              __pc=1;return;
            case 1:
              top=_thread.retVal;
              
              i = 0;
              
            case 2:
              if (!(i<_this.h)) { __pc=5     ; break; }
              if (!(my>=top+64*i&&my<=top+64*(i+1))) { __pc=3     ; break; }
              _thread.exit(i);return;
            case 3     :
              
            case 4     :
              i++;
              __pc=2;break;
            case 5     :
              
              _thread.exit(- 1);return;
              _thread.exit(_this);return;
            }
          }
        });
      },
      newDice :function _trc_Board_newDice(dx,dy,value) {
        "use strict";
        var _this=this;
        
        return new Tonyu.classes.user.DiceBoard({dx: dx,dy: dy,value: value,parent: _this});
      },
      fiber$newDice :function _trc_Board_f_newDice(_thread,dx,dy,value) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=new Tonyu.classes.user.DiceBoard({dx: dx,dy: dy,value: value,parent: _this});return;
        
        
        _thread.retVal=_this;return;
      },
      newDiceStartXY :function _trc_Board_newDiceStartXY(dx,dy,value,sx,sy) {
        "use strict";
        var _this=this;
        
        return new Tonyu.classes.user.DiceBoard({sx: sx,sy: sy,dx: dx,dy: dy,value: value,parent: _this});
      },
      fiber$newDiceStartXY :function _trc_Board_f_newDiceStartXY(_thread,dx,dy,value,sx,sy) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=new Tonyu.classes.user.DiceBoard({sx: sx,sy: sy,dx: dx,dy: dy,value: value,parent: _this});return;
        
        
        _thread.retVal=_this;return;
      },
      getDice :function _trc_Board_getDice(x,y) {
        "use strict";
        var _this=this;
        
        return _this.dices[y][x];
      },
      fiber$getDice :function _trc_Board_f_getDice(_thread,x,y) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=_this.dices[y][x];return;
        
        
        _thread.retVal=_this;return;
      },
      moveDice :function _trc_Board_moveDice(x,y,tx,ty) {
        "use strict";
        var _this=this;
        
        _this.dices[ty][tx]=_this.dices[y][x];
        _this.dices[y][x]=null;
        _this.dices[ty][tx].dtx=tx;
        _this.dices[ty][tx].dty=ty;
      },
      fiber$moveDice :function _trc_Board_f_moveDice(_thread,x,y,tx,ty) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.dices[ty][tx]=_this.dices[y][x];
        _this.dices[y][x]=null;
        _this.dices[ty][tx].dtx=tx;
        _this.dices[ty][tx].dty=ty;
        
        _thread.retVal=_this;return;
      },
      deleteDice :function _trc_Board_deleteDice(x,y) {
        "use strict";
        var _this=this;
        
        _this.dices[y][x]=null;
      },
      fiber$deleteDice :function _trc_Board_f_deleteDice(_thread,x,y) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.dices[y][x]=null;
        
        _thread.retVal=_this;return;
      },
      getValue :function _trc_Board_getValue(x,y) {
        "use strict";
        var _this=this;
        
        return _this.getDice(x,y).value;
      },
      fiber$getValue :function _trc_Board_f_getValue(_thread,x,y) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=_this.getDice(x,y).value;return;
        
        
        _thread.retVal=_this;return;
      },
      StartFly :function _trc_Board_StartFly(col) {
        "use strict";
        var _this=this;
        var cnt;
        var y;
        
        _this.highLightCol=- 1;
        cnt = 0;
        
        y = 0;
        for (; y<_this.h ; y++) {
          Tonyu.checkLoop();
          {
            if (! _this.dices[y][col]) {
              continue;
              
            }
            _this.dices[y][col].Fly();
            _this.dices[y][col]=null;
            cnt++;
          }
        }
        return cnt;
      },
      fiber$StartFly :function _trc_Board_f_StartFly(_thread,col) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var cnt;
        var y;
        
        _this.highLightCol=- 1;
        cnt = 0;
        
        y = 0;
        for (; y<_this.h ; y++) {
          Tonyu.checkLoop();
          {
            if (! _this.dices[y][col]) {
              continue;
              
            }
            _this.dices[y][col].Fly();
            _this.dices[y][col]=null;
            cnt++;
          }
        }
        _thread.retVal=cnt;return;
        
        
        _thread.retVal=_this;return;
      },
      StartShufleRow :function _trc_Board_StartShufleRow(row) {
        "use strict";
        var _this=this;
        var cnt;
        var vals;
        var x;
        
        _this.highLightRow=- 1;
        cnt = 0;
        
        vals = [];
        
        x = 0;
        for (; x<_this.h ; x++) {
          Tonyu.checkLoop();
          {
            if (! _this.dices[row][x]) {
              continue;
              
            }
            vals.push(_this.dices[row][x].value);
            cnt++;
          }
        }
        x = 0;
        for (; x<_this.h ; x++) {
          Tonyu.checkLoop();
          {
            if (! _this.dices[row][x]) {
              continue;
              
            }
            _this.dices[row][x].value=vals.splice(_this.rnd(vals.length),1)[0];
            cnt++;
          }
        }
        return cnt;
      },
      fiber$StartShufleRow :function _trc_Board_f_StartShufleRow(_thread,row) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var cnt;
        var vals;
        var x;
        
        _this.highLightRow=- 1;
        cnt = 0;
        
        vals = [];
        
        x = 0;
        for (; x<_this.h ; x++) {
          Tonyu.checkLoop();
          {
            if (! _this.dices[row][x]) {
              continue;
              
            }
            vals.push(_this.dices[row][x].value);
            cnt++;
          }
        }
        x = 0;
        for (; x<_this.h ; x++) {
          Tonyu.checkLoop();
          {
            if (! _this.dices[row][x]) {
              continue;
              
            }
            _this.dices[row][x].value=vals.splice(_this.rnd(vals.length),1)[0];
            cnt++;
          }
        }
        _thread.retVal=cnt;return;
        
        
        _thread.retVal=_this;return;
      },
      EndFly :function _trc_Board_EndFly(col,dices) {
        "use strict";
        var _this=this;
        var y;
        
        y = 0;
        for (; y<_this.h ; y++) {
          Tonyu.checkLoop();
          {
            if (! _this.dices[y][col]) {
              _this.dice=dices.pop();
              if (! _this.dice) {
                continue;
                
              }
              _this.dices[y][col]=_this.newDiceStartXY(col,y,_this.dice.value,col,y-6);
              
            }
          }
        }
      },
      fiber$EndFly :function _trc_Board_f_EndFly(_thread,col,dices) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var y;
        
        
        _thread.enter(function _trc_Board_ent_EndFly(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              y = 0;
              
            case 1:
              if (!(y<_this.h)) { __pc=6     ; break; }
              if (!(! _this.dices[y][col])) { __pc=4     ; break; }
              _this.dice=dices.pop();
              if (!(! _this.dice)) { __pc=2     ; break; }
              __pc=5     ; break;
              
            case 2     :
              
              _this.fiber$newDiceStartXY(_thread, col, y, _this.dice.value, col, y-6);
              __pc=3;return;
            case 3:
              _this.dices[y][col]=_thread.retVal;
              
            case 4     :
              
            case 5     :
              y++;
              __pc=1;break;
            case 6     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      StartFill :function _trc_Board_StartFill() {
        "use strict";
        var _this=this;
        var y;
        var x;
        
        y = 0;
        for (; y<_this.h ; y++) {
          Tonyu.checkLoop();
          {
            x = 0;
            for (; x<_this.w ; x++) {
              Tonyu.checkLoop();
              {
                if (! _this.dices[y][x]) {
                  _this.dices[y][x]=_this.newDiceStartXY(x,y,_this.rnd(6)+1,x,y-1);
                  
                }
              }
            }
          }
        }
      },
      fiber$StartFill :function _trc_Board_f_StartFill(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var y;
        var x;
        
        
        _thread.enter(function _trc_Board_ent_StartFill(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              y = 0;
              
            case 1:
              if (!(y<_this.h)) { __pc=8     ; break; }
              x = 0;
              
            case 2:
              if (!(x<_this.w)) { __pc=6     ; break; }
              if (!(! _this.dices[y][x])) { __pc=4     ; break; }
              _this.fiber$newDiceStartXY(_thread, x, y, _this.rnd(6)+1, x, y-1);
              __pc=3;return;
            case 3:
              _this.dices[y][x]=_thread.retVal;
              
            case 4     :
              
            case 5     :
              x++;
              __pc=2;break;
            case 6     :
              
            case 7     :
              y++;
              __pc=1;break;
            case 8     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      StartFall :function _trc_Board_StartFall() {
        "use strict";
        var _this=this;
        var y;
        var x;
        var endy;
        
        _this.highLightCol=- 1;
        _this.highLightRow=- 1;
        y = _this.h-1;
        for (; y>=0 ; y--) {
          Tonyu.checkLoop();
          {
            x = 0;
            for (; x<_this.w ; x++) {
              Tonyu.checkLoop();
              {
                if (! _this.dices[y][x]) {
                  continue;
                  
                }
                if (_this.isFall(x,y)) {
                  endy = _this.getFallY(x,y);
                  
                  if (endy-y>=1&&! _this.dices[y][x].Is56()) {
                    _this.dices[y][x].NextRoll();
                  }
                  if (endy-y>=2&&! _this.dices[y][x].Is56()) {
                    _this.dices[y][x].NextRoll();
                  }
                  if (endy-y>=3&&! _this.dices[y][x].Is56()) {
                    _this.dices[y][x].NextRoll();
                  }
                  if (endy-y>=4&&! _this.dices[y][x].Is56()) {
                    _this.dices[y][x].NextRoll();
                  }
                  if (endy-y>=5&&! _this.dices[y][x].Is56()) {
                    _this.dices[y][x].NextRoll();
                  }
                  _this.moveDice(x,y,x,endy);
                  
                }
              }
            }
          }
        }
      },
      fiber$StartFall :function _trc_Board_f_StartFall(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var y;
        var x;
        var endy;
        
        _this.highLightCol=- 1;
        _this.highLightRow=- 1;
        
        _thread.enter(function _trc_Board_ent_StartFall(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              y = _this.h-1;
              
            case 1:
              if (!(y>=0)) { __pc=10    ; break; }
              x = 0;
              
            case 2:
              if (!(x<_this.w)) { __pc=8     ; break; }
              if (!(! _this.dices[y][x])) { __pc=3     ; break; }
              __pc=7     ; break;
              
            case 3     :
              
              if (!(_this.isFall(x,y))) { __pc=6     ; break; }
              _this.fiber$getFallY(_thread, x, y);
              __pc=4;return;
            case 4:
              endy=_thread.retVal;
              
              if (endy-y>=1&&! _this.dices[y][x].Is56()) {
                _this.dices[y][x].NextRoll();
              }
              if (endy-y>=2&&! _this.dices[y][x].Is56()) {
                _this.dices[y][x].NextRoll();
              }
              if (endy-y>=3&&! _this.dices[y][x].Is56()) {
                _this.dices[y][x].NextRoll();
              }
              if (endy-y>=4&&! _this.dices[y][x].Is56()) {
                _this.dices[y][x].NextRoll();
              }
              if (endy-y>=5&&! _this.dices[y][x].Is56()) {
                _this.dices[y][x].NextRoll();
              }
              _this.fiber$moveDice(_thread, x, y, x, endy);
              __pc=5;return;
            case 5:
              
            case 6     :
              
            case 7     :
              x++;
              __pc=2;break;
            case 8     :
              
            case 9     :
              y--;
              __pc=1;break;
            case 10    :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      isFall :function _trc_Board_isFall(x,y) {
        "use strict";
        var _this=this;
        
        if (y+1>=_this.h) {
          return false;
        }
        if (! _this.dices[y+1][x]) {
          return true;
        }
      },
      fiber$isFall :function _trc_Board_f_isFall(_thread,x,y) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (y+1>=_this.h) {
          _thread.retVal=false;return;
          
        }
        if (! _this.dices[y+1][x]) {
          _thread.retVal=true;return;
          
        }
        
        _thread.retVal=_this;return;
      },
      getFallY :function _trc_Board_getFallY(x,y) {
        "use strict";
        var _this=this;
        var vy;
        var cnt;
        
        vy = y+1;
        
        if (vy>_this.h) {
          return y;
        }
        cnt = 0;
        
        while (! _this.dices[vy+cnt][x]) {
          Tonyu.checkLoop();
          cnt++;
          if (vy+cnt>=_this.h) {
            return y+cnt;
          }
          
        }
        return y+cnt;
      },
      fiber$getFallY :function _trc_Board_f_getFallY(_thread,x,y) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var vy;
        var cnt;
        
        vy = y+1;
        
        if (vy>_this.h) {
          _thread.retVal=y;return;
          
        }
        cnt = 0;
        
        
        _thread.enter(function _trc_Board_ent_getFallY(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (!(! _this.dices[vy+cnt][x])) { __pc=3     ; break; }
              cnt++;
              if (!(vy+cnt>=_this.h)) { __pc=2     ; break; }
              _thread.exit(y+cnt);return;
            case 2     :
              
              __pc=1;break;
            case 3     :
              
              _thread.exit(y+cnt);return;
              _thread.exit(_this);return;
            }
          }
        });
      },
      StartCheck :function _trc_Board_StartCheck() {
        "use strict";
        var _this=this;
        var ok;
        var nextDeleteStacks;
        var y;
        var x;
        var stack;
        
        _this.highLightCol=- 1;
        ok = 0;
        
        nextDeleteStacks = [];
        
        y = 0;
        for (; y<_this.h ; y++) {
          Tonyu.checkLoop();
          {
            x = 0;
            for (; x<_this.w ; x++) {
              Tonyu.checkLoop();
              {
                if (! _this.dices[y][x]) {
                  continue;
                  
                }
                
                stack = _this.chkAndMarkErase(x,y,1,0);
                
                if (stack) {
                  nextDeleteStacks.push(stack);
                }
                stack = _this.chkAndMarkErase(x,y,0,1);
                
                if (stack) {
                  nextDeleteStacks.push(stack);
                }
              }
            }
          }
        }
        _this.deleteStacks(nextDeleteStacks);
        return nextDeleteStacks.length;
      },
      fiber$StartCheck :function _trc_Board_f_StartCheck(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var ok;
        var nextDeleteStacks;
        var y;
        var x;
        var stack;
        
        _this.highLightCol=- 1;
        ok = 0;
        
        nextDeleteStacks = [];
        
        
        _thread.enter(function _trc_Board_ent_StartCheck(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              y = 0;
              
            case 1:
              if (!(y<_this.h)) { __pc=9     ; break; }
              x = 0;
              
            case 2:
              if (!(x<_this.w)) { __pc=7     ; break; }
              if (!(! _this.dices[y][x])) { __pc=3     ; break; }
              __pc=6     ; break;
              
            case 3     :
              
              
              _this.fiber$chkAndMarkErase(_thread, x, y, 1, 0);
              __pc=4;return;
            case 4:
              stack=_thread.retVal;
              
              if (stack) {
                nextDeleteStacks.push(stack);
              }
              _this.fiber$chkAndMarkErase(_thread, x, y, 0, 1);
              __pc=5;return;
            case 5:
              stack=_thread.retVal;
              
              if (stack) {
                nextDeleteStacks.push(stack);
              }
            case 6     :
              x++;
              __pc=2;break;
            case 7     :
              
            case 8     :
              y++;
              __pc=1;break;
            case 9     :
              
              _this.fiber$deleteStacks(_thread, nextDeleteStacks);
              __pc=10;return;
            case 10:
              
              _thread.exit(nextDeleteStacks.length);return;
              _thread.exit(_this);return;
            }
          }
        });
      },
      deleteStacks :function _trc_Board_deleteStacks(stacks) {
        "use strict";
        var _this=this;
        var si;
        var i;
        var dice;
        
        si = 0;
        for (; si<stacks.length ; si++) {
          Tonyu.checkLoop();
          {
            i = 0;
            for (; i<stacks[si].length ; i++) {
              Tonyu.checkLoop();
              {
                dice = stacks[si][i];
                
                _this.deleteDice(dice.dx,dice.dy);
              }
            }
          }
        }
      },
      fiber$deleteStacks :function _trc_Board_f_deleteStacks(_thread,stacks) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var si;
        var i;
        var dice;
        
        
        _thread.enter(function _trc_Board_ent_deleteStacks(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              si = 0;
              
            case 1:
              if (!(si<stacks.length)) { __pc=7     ; break; }
              i = 0;
              
            case 2:
              if (!(i<stacks[si].length)) { __pc=5     ; break; }
              dice = stacks[si][i];
              
              _this.fiber$deleteDice(_thread, dice.dx, dice.dy);
              __pc=3;return;
            case 3:
              
            case 4     :
              i++;
              __pc=2;break;
            case 5     :
              
            case 6     :
              si++;
              __pc=1;break;
            case 7     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      chkAndMarkErase :function _trc_Board_chkAndMarkErase(x,y,vx,vy) {
        "use strict";
        var _this=this;
        var stack;
        
        stack = _this.chkErase([],5,x,y,vx,vy);
        
        if (_this.enoughStack(stack)) {
          return _this.markErase(stack);
          
        }
        return false;
      },
      fiber$chkAndMarkErase :function _trc_Board_f_chkAndMarkErase(_thread,x,y,vx,vy) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var stack;
        
        
        _thread.enter(function _trc_Board_ent_chkAndMarkErase(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$chkErase(_thread, [], 5, x, y, vx, vy);
              __pc=1;return;
            case 1:
              stack=_thread.retVal;
              
              if (!(_this.enoughStack(stack))) { __pc=3     ; break; }
              _this.fiber$markErase(_thread, stack);
              __pc=2;return;
            case 2:
              _thread.exit(_thread.retVal);return;
              
            case 3     :
              
              _thread.exit(false);return;
              _thread.exit(_this);return;
            }
          }
        });
      },
      enoughStack :function _trc_Board_enoughStack(stack) {
        "use strict";
        var _this=this;
        
        return stack.length>=2;
      },
      fiber$enoughStack :function _trc_Board_f_enoughStack(_thread,stack) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=stack.length>=2;return;
        
        
        _thread.retVal=_this;return;
      },
      chkErase :function _trc_Board_chkErase(stack,needle,x,y,vx,vy) {
        "use strict";
        var _this=this;
        var nextneedle;
        
        if (x>=_this.w||y>=_this.h||! _this.dices[y][x]) {
          return stack;
        }
        nextneedle = needle==5?6:5;
        
        if (_this.getValue(x,y)==needle) {
          stack.push(_this.getDice(x,y));
          return _this.chkErase(stack,nextneedle,x+vx,y+vy,vx,vy);
          
        }
        return stack;
      },
      fiber$chkErase :function _trc_Board_f_chkErase(_thread,stack,needle,x,y,vx,vy) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var nextneedle;
        
        if (x>=_this.w||y>=_this.h||! _this.dices[y][x]) {
          _thread.retVal=stack;return;
          
        }
        nextneedle = needle==5?6:5;
        
        
        _thread.enter(function _trc_Board_ent_chkErase(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              if (!(_this.getValue(x,y)==needle)) { __pc=2     ; break; }
              stack.push(_this.getDice(x,y));
              _this.fiber$chkErase(_thread, stack, nextneedle, x+vx, y+vy, vx, vy);
              __pc=1;return;
            case 1:
              _thread.exit(_thread.retVal);return;
              
            case 2     :
              
              _thread.exit(stack);return;
              _thread.exit(_this);return;
            }
          }
        });
      },
      markErase :function _trc_Board_markErase(dices) {
        "use strict";
        var _this=this;
        var i;
        var dice;
        
        if (dices.length%2==1) {
          dices.pop();
        }
        i = 0;
        for (; i<dices.length ; i++) {
          Tonyu.checkLoop();
          {
            dice = dices[i];
            
            dice.Erase(dices.length);
          }
        }
        return dices;
      },
      fiber$markErase :function _trc_Board_f_markErase(_thread,dices) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var i;
        var dice;
        
        if (dices.length%2==1) {
          dices.pop();
        }
        i = 0;
        for (; i<dices.length ; i++) {
          Tonyu.checkLoop();
          {
            dice = dices[i];
            
            dice.Erase(dices.length);
          }
        }
        _thread.retVal=dices;return;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"draw":{"nowait":true},"Init":{"nowait":false},"getTop":{"nowait":false},"getLeft":{"nowait":false},"SetHighLightFromX":{"nowait":false},"SetHighLightFromY":{"nowait":false},"getCol":{"nowait":false},"getRow":{"nowait":false},"newDice":{"nowait":false},"newDiceStartXY":{"nowait":false},"getDice":{"nowait":false},"moveDice":{"nowait":false},"deleteDice":{"nowait":false},"getValue":{"nowait":false},"StartFly":{"nowait":false},"StartShufleRow":{"nowait":false},"EndFly":{"nowait":false},"StartFill":{"nowait":false},"StartFall":{"nowait":false},"isFall":{"nowait":false},"getFallY":{"nowait":false},"StartCheck":{"nowait":false},"deleteStacks":{"nowait":false},"chkAndMarkErase":{"nowait":false},"enoughStack":{"nowait":false},"chkErase":{"nowait":false},"markErase":{"nowait":false}},"fields":{"h":{},"w":{},"dice":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Dice',
  shortName: 'Dice',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Dice_main() {
        "use strict";
        var _this=this;
        
      },
      fiber$main :function _trc_Dice_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.retVal=_this;return;
      },
      initialize :function _trc_Dice_initialize(o) {
        "use strict";
        var _this=this;
        
        __superClass.apply( _this, [o]);
        _this._value=o.value;
        _this.p=o.value+Tonyu.globals.$pat_dice56r-1||1;
        _this.size=64;
        _this.tRot=0;
      },
      __getter__value :function _trc_Dice___getter__value() {
        "use strict";
        var _this=this;
        
        return _this._value;
      },
      __setter__value :function _trc_Dice___setter__value(v) {
        "use strict";
        var _this=this;
        
        _this._value=v;
        _this.p=v+Tonyu.globals.$pat_dice56r-1||1;
      },
      NextRoll :function _trc_Dice_NextRoll() {
        "use strict";
        var _this=this;
        var rs;
        
        if (_this.value==1||_this.value==6) {
          _this.value=_this.rnd(4)+2;
        } else {
          if (_this.value==2||_this.value==5) {
            rs = [1,3,4,6];
            
            _this.value=rs[_this.rnd(4)];
            
          } else {
            if (_this.value==3||_this.value==4) {
              _this.value=_this.rnd(2)==0?_this.rnd(2)+1:_this.rnd(2)+5;
            }
          }
        }
        _this.tRot+=90;
      },
      fiber$NextRoll :function _trc_Dice_f_NextRoll(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var rs;
        
        if (_this.value==1||_this.value==6) {
          _this.value=_this.rnd(4)+2;
        } else {
          if (_this.value==2||_this.value==5) {
            rs = [1,3,4,6];
            
            _this.value=rs[_this.rnd(4)];
            
          } else {
            if (_this.value==3||_this.value==4) {
              _this.value=_this.rnd(2)==0?_this.rnd(2)+1:_this.rnd(2)+5;
            }
          }
        }
        _this.tRot+=90;
        
        _thread.retVal=_this;return;
      },
      Is56 :function _trc_Dice_Is56() {
        "use strict";
        var _this=this;
        
        return (_this.value==5||_this.value==6);
      },
      fiber$Is56 :function _trc_Dice_f_Is56(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=(_this.value==5||_this.value==6);return;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"__getter__value":{"nowait":true},"__setter__value":{"nowait":true},"NextRoll":{"nowait":false},"Is56":{"nowait":false}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.DiceBoard',
  shortName: 'DiceBoard',
  namespace: 'user',
  superclass: Tonyu.classes.user.Dice,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_DiceBoard_main() {
        "use strict";
        var _this=this;
        
        while (! _this.isErased&&! _this.isFly) {
          Tonyu.checkLoop();
          if (! _this.isErased&&_this.maxPow!=0) {
            Tonyu.globals.$GameMain.PowerScore(_this.maxPow);
            if (_this.maxPow>4) {
              new Tonyu.classes.user.Fx565656({x: _this.x,y: _this.y});
            } else {
              if (_this.maxPow>2) {
                new Tonyu.classes.user.Fx5656({x: _this.x,y: _this.y});
              }
            }
            _this.isErased=true;
            
          }
          _this._x+=_this.getSlideAmount(_this._x,_this.tx,0.1);
          _this._y+=_this.getSlideAmount(_this._y,_this.ty,0.1);
          _this.rotation+=_this.getSlideAmount(_this.rotation,_this.tRot,0.05);
          _this.update();
          
        }
        while (_this.isFly) {
          Tonyu.checkLoop();
          _this._x+=_this.getSlideAmount(_this._x,_this.tx,0.1);
          _this._y+=_this.getSlideAmount(_this._y,_this.ty,0.1);
          _this.alpha-=7;
          if (_this.alpha<5) {
            _this.die();
          }
          _this.update();
          
        }
        _this.tx=- Tonyu.globals.$screenWidth/2;
        _this.ty=- Tonyu.globals.$screenHeight/2;
        while (_this.isErased) {
          Tonyu.checkLoop();
          _this.scaleX*=0.98;
          _this._x+=_this.getSlideAmount(_this._x,_this.tx,0.1);
          _this._y+=_this.getSlideAmount(_this._y,_this.ty,0.1);
          _this.alpha-=4;
          if (_this.alpha<5) {
            _this.die();
          }
          _this.update();
          
        }
      },
      fiber$main :function _trc_DiceBoard_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.enter(function _trc_DiceBoard_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (!(! _this.isErased&&! _this.isFly)) { __pc=3     ; break; }
              if (! _this.isErased&&_this.maxPow!=0) {
                Tonyu.globals.$GameMain.PowerScore(_this.maxPow);
                if (_this.maxPow>4) {
                  new Tonyu.classes.user.Fx565656({x: _this.x,y: _this.y});
                } else {
                  if (_this.maxPow>2) {
                    new Tonyu.classes.user.Fx5656({x: _this.x,y: _this.y});
                  }
                }
                _this.isErased=true;
                
              }
              _this._x+=_this.getSlideAmount(_this._x,_this.tx,0.1);
              _this._y+=_this.getSlideAmount(_this._y,_this.ty,0.1);
              _this.rotation+=_this.getSlideAmount(_this.rotation,_this.tRot,0.05);
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
            case 4:
              if (!(_this.isFly)) { __pc=6     ; break; }
              _this._x+=_this.getSlideAmount(_this._x,_this.tx,0.1);
              _this._y+=_this.getSlideAmount(_this._y,_this.ty,0.1);
              _this.alpha-=7;
              if (_this.alpha<5) {
                _this.die();
              }
              _this.fiber$update(_thread);
              __pc=5;return;
            case 5:
              
              __pc=4;break;
            case 6     :
              
              _this.tx=- Tonyu.globals.$screenWidth/2;
              _this.ty=- Tonyu.globals.$screenHeight/2;
            case 7:
              if (!(_this.isErased)) { __pc=9     ; break; }
              _this.scaleX*=0.98;
              _this._x+=_this.getSlideAmount(_this._x,_this.tx,0.1);
              _this._y+=_this.getSlideAmount(_this._y,_this.ty,0.1);
              _this.alpha-=4;
              if (_this.alpha<5) {
                _this.die();
              }
              _this.fiber$update(_thread);
              __pc=8;return;
            case 8:
              
              __pc=7;break;
            case 9     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      initialize :function _trc_DiceBoard_initialize(o) {
        "use strict";
        var _this=this;
        
        __superClass.apply( _this, [o]);
        _this.parent=o.parent;
        _this.tx=(o.x||0+_this.dx*_this.size+_this.size/2-_this.parent.w*_this.size/2);
        _this.ty=(o.y||0+_this.dy*_this.size+_this.size/2-_this.parent.h*_this.size/2);
        _this._x=o.sx!=null?(o.x||0+_this.sx*_this.size+_this.size/2-_this.parent.w*_this.size/2):_this.tx;
        _this._y=o.sy!=null?(o.y||0+_this.sy*_this.size+_this.size/2-_this.parent.h*_this.size/2):_this.ty;
        _this.maxPow=0;
        _this.isErased=false;
        _this.isFly=false;
      },
      __getter__x :function _trc_DiceBoard___getter__x() {
        "use strict";
        var _this=this;
        
        return _this.parent.x+_this._x;
      },
      __getter__y :function _trc_DiceBoard___getter__y() {
        "use strict";
        var _this=this;
        
        return _this.parent.y+_this._y;
      },
      __setter__x :function _trc_DiceBoard___setter__x(v) {
        "use strict";
        var _this=this;
        
        return _this._x=v-_this.parent.x;
      },
      __setter__y :function _trc_DiceBoard___setter__y(v) {
        "use strict";
        var _this=this;
        
        return _this._y=v-_this.parent.y;
      },
      __setter__dtx :function _trc_DiceBoard___setter__dtx(v) {
        "use strict";
        var _this=this;
        
        _this.tx=v*_this.size+_this.size/2-_this.parent.w*_this.size/2;
        _this.dx=v;
      },
      __setter__dty :function _trc_DiceBoard___setter__dty(v) {
        "use strict";
        var _this=this;
        
        _this.ty=v*_this.size+_this.size/2-_this.parent.h*_this.size/2;
        _this.dy=v;
      },
      Erase :function _trc_DiceBoard_Erase(power) {
        "use strict";
        var _this=this;
        
        if (power>_this.maxPow) {
          _this.maxPow=power;
          
        }
      },
      fiber$Erase :function _trc_DiceBoard_f_Erase(_thread,power) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (power>_this.maxPow) {
          _this.maxPow=power;
          
        }
        
        _thread.retVal=_this;return;
      },
      Fly :function _trc_DiceBoard_Fly() {
        "use strict";
        var _this=this;
        
        _this.ty-=512;
        _this.isFly=true;
      },
      fiber$Fly :function _trc_DiceBoard_f_Fly(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.ty-=512;
        _this.isFly=true;
        
        _thread.retVal=_this;return;
      },
      getSlideAmount :function _trc_DiceBoard_getSlideAmount(orig,target,ratio) {
        "use strict";
        var _this=this;
        var diff;
        
        ratio=ratio<=1?ratio:1;
        diff = target-orig;
        
        if (_this.abs(diff)>0.1) {
          return diff*ratio;
          
        } else {
          return diff;
          
        }
      },
      fiber$getSlideAmount :function _trc_DiceBoard_f_getSlideAmount(_thread,orig,target,ratio) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var diff;
        
        ratio=ratio<=1?ratio:1;
        diff = target-orig;
        
        if (_this.abs(diff)>0.1) {
          _thread.retVal=diff*ratio;return;
          
          
        } else {
          _thread.retVal=diff;return;
          
          
        }
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"__getter__x":{"nowait":true},"__getter__y":{"nowait":true},"__setter__x":{"nowait":true},"__setter__y":{"nowait":true},"__setter__dtx":{"nowait":true},"__setter__dty":{"nowait":true},"Erase":{"nowait":false},"Fly":{"nowait":false},"getSlideAmount":{"nowait":false}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.DiceFly',
  shortName: 'DiceFly',
  namespace: 'user',
  superclass: Tonyu.classes.user.Dice,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_DiceFly_main() {
        "use strict";
        var _this=this;
        
        _this.t = 0;
        
        _this.rv = _this.rnd(2)?1:- 1;
        
        while (! _this.isStop) {
          Tonyu.checkLoop();
          if (_this.t>_this.vt) {
            _this.value=_this.rnd(2)+5;
            _this.t=0;
            
          }
          _this.touch = _this.findTouch();
          
          if (_this.touch) {
            _this.Stop();
            
          }
          if (_this.x+_this.vx<0||_this.x+_this.vx>Tonyu.globals.$screenWidth) {
            _this.vx=- _this.vx;
            
          }
          if (_this._y+_this.vy<_this.heightY||_this._y+_this.vy>_this.heightY+Tonyu.globals.$screenHeight) {
            _this.vy=- _this.vy;
            
          }
          _this.x+=_this.vx;
          _this._y+=_this.vy;
          _this.t++;
          _this.rotation+=(_this.vt*_this.rv)/4;
          _this.update();
          
        }
      },
      fiber$main :function _trc_DiceFly_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.t = 0;
        
        _this.rv = _this.rnd(2)?1:- 1;
        
        
        _thread.enter(function _trc_DiceFly_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (!(! _this.isStop)) { __pc=5     ; break; }
              if (_this.t>_this.vt) {
                _this.value=_this.rnd(2)+5;
                _this.t=0;
                
              }
              _this.touch = _this.findTouch();
              
              if (!(_this.touch)) { __pc=3     ; break; }
              _this.fiber$Stop(_thread);
              __pc=2;return;
            case 2:
              
            case 3     :
              
              if (_this.x+_this.vx<0||_this.x+_this.vx>Tonyu.globals.$screenWidth) {
                _this.vx=- _this.vx;
                
              }
              if (_this._y+_this.vy<_this.heightY||_this._y+_this.vy>_this.heightY+Tonyu.globals.$screenHeight) {
                _this.vy=- _this.vy;
                
              }
              _this.x+=_this.vx;
              _this._y+=_this.vy;
              _this.t++;
              _this.rotation+=(_this.vt*_this.rv)/4;
              _this.fiber$update(_thread);
              __pc=4;return;
            case 4:
              
              __pc=1;break;
            case 5     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      initialize :function _trc_DiceFly_initialize(o) {
        "use strict";
        var _this=this;
        
        __superClass.apply( _this, [o]);
        Tonyu.globals.$RotateFlyDiceCnt++;
        _this.parent=o.parent;
        _this.heightY=o.heightY;
        _this._y=o.y;
        _this.vx=o.vx||_this.rnd(12)-5.5;
        _this.vy=o.vy||_this.rnd(12)-5.5;
        _this.vt=o.vt||12+_this.rnd(12);
        _this.isStop=false;
      },
      __getter__y :function _trc_DiceFly___getter__y() {
        "use strict";
        var _this=this;
        
        return _this.parent.y+_this._y;
      },
      __setter__y :function _trc_DiceFly___setter__y(v) {
        "use strict";
        var _this=this;
        
        return _this._y=v-_this.parent.y;
      },
      Stop :function _trc_DiceFly_Stop() {
        "use strict";
        var _this=this;
        
        if (! _this.isStop) {
          Tonyu.globals.$RotateFlyDiceCnt--;
          Tonyu.globals.$sound.playSE(Tonyu.globals.$se_hit82,64);
          
        }
        _this.isStop=true;
      },
      fiber$Stop :function _trc_DiceFly_f_Stop(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (! _this.isStop) {
          Tonyu.globals.$RotateFlyDiceCnt--;
          Tonyu.globals.$sound.playSE(Tonyu.globals.$se_hit82,64);
          
        }
        _this.isStop=true;
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"__getter__y":{"nowait":true},"__setter__y":{"nowait":true},"Stop":{"nowait":false}},"fields":{"t":{},"rv":{},"touch":{},"isStop":{},"vx":{},"_y":{},"vy":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Fx5656',
  shortName: 'Fx5656',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Fx5656_main() {
        "use strict";
        var _this=this;
        
        _this.radius=_this.radius?_this.radius:32;
        _this.fillStyle="#fff";
        _this.scaleX=3;
        _this.zOrder=- 9;
        _this.t = 120;
        
        _this.maxt = _this.t;
        
        _this.color = "#fff";
        
        Tonyu.globals.$sound.playSE(Tonyu.globals.$se_up,64);
        while (_this.t) {
          Tonyu.checkLoop();
          if (_this.scaleX>1) {
            _this.scaleX*=0.95;
            
          } else {
            _this.scaleX=1;
            
          }
          _this.t--;
          _this.update();
          
        }
        while (_this.alpha>0) {
          Tonyu.checkLoop();
          _this.alpha-=5;
          _this.update();
          
        }
        _this.die();
      },
      fiber$main :function _trc_Fx5656_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.radius=_this.radius?_this.radius:32;
        _this.fillStyle="#fff";
        _this.scaleX=3;
        _this.zOrder=- 9;
        _this.t = 120;
        
        _this.maxt = _this.t;
        
        _this.color = "#fff";
        
        Tonyu.globals.$sound.playSE(Tonyu.globals.$se_up,64);
        
        _thread.enter(function _trc_Fx5656_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (!(_this.t)) { __pc=3     ; break; }
              if (_this.scaleX>1) {
                _this.scaleX*=0.95;
                
              } else {
                _this.scaleX=1;
                
              }
              _this.t--;
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
            case 4:
              if (!(_this.alpha>0)) { __pc=6     ; break; }
              _this.alpha-=5;
              _this.fiber$update(_thread);
              __pc=5;return;
            case 5:
              
              __pc=4;break;
            case 6     :
              
              _this.die();
              _thread.exit(_this);return;
            }
          }
        });
      },
      draw :function _trc_Fx5656_draw(ctx) {
        "use strict";
        var _this=this;
        var y;
        var x;
        var textObj;
        
        ctx.save();
        y = _this.y;
        
        x = _this.x;
        
        _this.color=_this.rnd(2)==0?"rgba(255,255,0,"+_this.alpha/255+")":"rgba(255,255,255,"+_this.alpha/255+")";
        textObj = Tonyu.globals.$UI.Text({ctx: ctx,x: x,y: y,text: "5656",size: 32*_this.scaleX,textBaseline: "center",align: "center",color: Tonyu.bindFunc(_this,_this.color),alpha: _this.alpha});
        
        ctx.restore();
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"draw":{"nowait":true}},"fields":{"t":{},"maxt":{},"color":{}}}
});
Tonyu.klass.define({
  fullName: 'user.GameMain',
  shortName: 'GameMain',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_GameMain_main() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$GameMain=_this;
        Tonyu.globals.$Scene=0;
        Tonyu.globals.$Score=0;
        Tonyu.globals.$combo=1;
        _this.board = new Tonyu.classes.user.Board({x: Tonyu.globals.$screenWidth/2,y: Tonyu.globals.$screenHeight/2});
        
        _this.board.Init();
        _this.selectCol=- 1;
        _this.cty = Tonyu.globals.$screenHeight/2;
        
        new Tonyu.classes.kernel.Label({x: 0,y: 0,size: 32,align: "left top",template: "score:$Score"});
        _this.scoreLabel = new Tonyu.classes.kernel.Label({x: 0,y: 32,size: 16,align: "left top",text: "5656dice"});
        
        _this.desc = new Tonyu.classes.kernel.Label({x: Tonyu.globals.$screenWidth/2,y: 42,size: 32,align: "top",text: ""});
        
        _this.desc2 = new Tonyu.classes.kernel.Label({x: Tonyu.globals.$screenWidth/2,y: Tonyu.globals.$screenHeight-100,size: 16,align: "top",text: "運ゲーパズル"});
        
        _this.nextIsFly = true;
        
        while (1) {
          Tonyu.checkLoop();
          while (Tonyu.globals.$Scene==0) {
            Tonyu.checkLoop();
            _this.desc.text="56が完成でスコア";
            _this.SceneFall();
            _this.update();
            
          }
          _this.desc2.text="";
          while (Tonyu.globals.$Scene==1) {
            Tonyu.checkLoop();
            _this.desc.text=_this.nextIsFly?"列を飛ばす":"選んだ行をシャッフル";
            _this.SceneBoard();
            _this.update();
            
          }
          _this.desc2.text="空中";
          while (Tonyu.globals.$Scene==2) {
            Tonyu.checkLoop();
            Tonyu.globals.$twBtn.top=Tonyu.globals.$screenHeight+20;
            _this.desc.text="回転を止める";
            _this.SceneFly();
            _this.update();
            
          }
          Tonyu.globals.$twBtn.top=Tonyu.globals.$screenHeight-60;
          _this.nextIsFly=! _this.nextIsFly;
          _this.desc2.text="ダイスはゴロゴロ回転して落下する…！";
          
        }
      },
      fiber$main :function _trc_GameMain_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$GameMain=_this;
        Tonyu.globals.$Scene=0;
        Tonyu.globals.$Score=0;
        Tonyu.globals.$combo=1;
        _this.board = new Tonyu.classes.user.Board({x: Tonyu.globals.$screenWidth/2,y: Tonyu.globals.$screenHeight/2});
        
        _this.board.Init();
        _this.selectCol=- 1;
        _this.cty = Tonyu.globals.$screenHeight/2;
        
        new Tonyu.classes.kernel.Label({x: 0,y: 0,size: 32,align: "left top",template: "score:$Score"});
        _this.scoreLabel = new Tonyu.classes.kernel.Label({x: 0,y: 32,size: 16,align: "left top",text: "5656dice"});
        
        _this.desc = new Tonyu.classes.kernel.Label({x: Tonyu.globals.$screenWidth/2,y: 42,size: 32,align: "top",text: ""});
        
        _this.desc2 = new Tonyu.classes.kernel.Label({x: Tonyu.globals.$screenWidth/2,y: Tonyu.globals.$screenHeight-100,size: 16,align: "top",text: "運ゲーパズル"});
        
        _this.nextIsFly = true;
        
        
        _thread.enter(function _trc_GameMain_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (!(1)) { __pc=14    ; break; }
            case 2:
              if (!(Tonyu.globals.$Scene==0)) { __pc=5     ; break; }
              _this.desc.text="56が完成でスコア";
              _this.fiber$SceneFall(_thread);
              __pc=3;return;
            case 3:
              
              _this.fiber$update(_thread);
              __pc=4;return;
            case 4:
              
              __pc=2;break;
            case 5     :
              
              _this.desc2.text="";
            case 6:
              if (!(Tonyu.globals.$Scene==1)) { __pc=9     ; break; }
              _this.desc.text=_this.nextIsFly?"列を飛ばす":"選んだ行をシャッフル";
              _this.fiber$SceneBoard(_thread);
              __pc=7;return;
            case 7:
              
              _this.fiber$update(_thread);
              __pc=8;return;
            case 8:
              
              __pc=6;break;
            case 9     :
              
              _this.desc2.text="空中";
            case 10:
              if (!(Tonyu.globals.$Scene==2)) { __pc=13    ; break; }
              Tonyu.globals.$twBtn.top=Tonyu.globals.$screenHeight+20;
              _this.desc.text="回転を止める";
              _this.fiber$SceneFly(_thread);
              __pc=11;return;
            case 11:
              
              _this.fiber$update(_thread);
              __pc=12;return;
            case 12:
              
              __pc=10;break;
            case 13    :
              
              Tonyu.globals.$twBtn.top=Tonyu.globals.$screenHeight-60;
              _this.nextIsFly=! _this.nextIsFly;
              _this.desc2.text="ダイスはゴロゴロ回転して落下する…！";
              __pc=1;break;
            case 14    :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      SceneFall :function _trc_GameMain_SceneFall() {
        "use strict";
        var _this=this;
        var isFall;
        
        Tonyu.globals.$combo=1;
        isFall = _this.board.StartCheck();
        
        while (isFall) {
          Tonyu.checkLoop();
          Tonyu.globals.$sound.playSE(Tonyu.globals.$se_shoot21,64);
          _this.board.StartFall();
          _this.board.StartFill();
          _this.updateEx(30);
          isFall=_this.board.StartCheck();
          Tonyu.globals.$combo+=1;
          
        }
        Tonyu.globals.$sound.playSE(Tonyu.globals.$se_whistle00,54);
        Tonyu.globals.$Scene=1;
      },
      fiber$SceneFall :function _trc_GameMain_f_SceneFall(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var isFall;
        
        Tonyu.globals.$combo=1;
        isFall = _this.board.StartCheck();
        
        
        _thread.enter(function _trc_GameMain_ent_SceneFall(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (!(isFall)) { __pc=3     ; break; }
              Tonyu.globals.$sound.playSE(Tonyu.globals.$se_shoot21,64);
              _this.board.StartFall();
              _this.board.StartFill();
              _this.fiber$updateEx(_thread, 30);
              __pc=2;return;
            case 2:
              
              isFall=_this.board.StartCheck();
              Tonyu.globals.$combo+=1;
              __pc=1;break;
            case 3     :
              
              Tonyu.globals.$sound.playSE(Tonyu.globals.$se_whistle00,54);
              Tonyu.globals.$Scene=1;
              _thread.exit(_this);return;
            }
          }
        });
      },
      SceneBoard :function _trc_GameMain_SceneBoard() {
        "use strict";
        var _this=this;
        
        if (_this.nextIsFly) {
          if (_this.board.highLightCol!=- 1&&Tonyu.globals.$touches[0].touched==1) {
            _this.selectCol=_this.board.highLightCol;
            Tonyu.globals.$Scene=2;
            return _this;
            
          }
          _this.board.SetHighLightFromX(Tonyu.globals.$mouseX);
          
        } else {
          if (_this.board.highLightRow!=- 1&&Tonyu.globals.$touches[0].touched==1) {
            _this.selectRow=_this.board.highLightRow;
            _this.board.StartShufleRow(_this.selectRow);
            Tonyu.globals.$sound.playSE(Tonyu.globals.$se_power22,64);
            _this.updateEx(30);
            Tonyu.globals.$Scene=0;
            return _this;
            
          }
          _this.board.SetHighLightFromY(Tonyu.globals.$mouseY);
          
        }
      },
      fiber$SceneBoard :function _trc_GameMain_f_SceneBoard(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.enter(function _trc_GameMain_ent_SceneBoard(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              if (!(_this.nextIsFly)) { __pc=2     ; break; }
              if (!(_this.board.highLightCol!=- 1&&Tonyu.globals.$touches[0].touched==1)) { __pc=1     ; break; }
              _this.selectCol=_this.board.highLightCol;
              Tonyu.globals.$Scene=2;
              _thread.exit(_this);return;
            case 1     :
              
              _this.board.SetHighLightFromX(Tonyu.globals.$mouseX);
              __pc=5     ;break;
            case 2     :
              if (!(_this.board.highLightRow!=- 1&&Tonyu.globals.$touches[0].touched==1)) { __pc=4     ; break; }
              _this.selectRow=_this.board.highLightRow;
              _this.board.StartShufleRow(_this.selectRow);
              Tonyu.globals.$sound.playSE(Tonyu.globals.$se_power22,64);
              _this.fiber$updateEx(_thread, 30);
              __pc=3;return;
            case 3:
              
              Tonyu.globals.$Scene=0;
              _thread.exit(_this);return;
            case 4     :
              
              _this.board.SetHighLightFromY(Tonyu.globals.$mouseY);
            case 5     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      SceneFly :function _trc_GameMain_SceneFly() {
        "use strict";
        var _this=this;
        var cnt;
        var velocitys;
        var ty;
        var dices;
        var i;
        var vx;
        var vy;
        var t;
        
        Tonyu.globals.$sound.playSE(Tonyu.globals.$se_shoot08,80);
        _this.all(Tonyu.classes.user.DiceFly).die();
        cnt = _this.board.StartFly(_this.selectCol);
        
        _this.board.StartFall();
        Tonyu.globals.$RotateFlyDiceCnt=0;
        velocitys = [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20];
        
        ty = Tonyu.globals.$screenHeight*2;
        
        dices = [];
        
        i = 0;
        for (; i<cnt ; i++) {
          Tonyu.checkLoop();
          {
            vx = (velocitys.splice(_this.rnd(velocitys.length),1)[0]-10)/2;
            
            vy = (velocitys.splice(_this.rnd(velocitys.length),1)[0]-10)/2;
            
            dices.push(new Tonyu.classes.user.DiceFly({parent: _this.board,x: _this.rnd(Tonyu.globals.$screenWidth),y: _this.rnd(Tonyu.globals.$screenHeight)-ty,heightY: - ty,vx: vx,vy: vy,value: _this.rnd(6)+1}));
          }
        }
        while (Tonyu.globals.$RotateFlyDiceCnt>0) {
          Tonyu.checkLoop();
          _this.board.y+=_this.getSlideAmount(_this.board.y,ty,0.1);
          _this.update();
          
        }
        t = 0;
        
        _this.cty=Tonyu.globals.$screenHeight/2;
        _this.board.EndFly(_this.selectCol,dices);
        while (_this.board.y>=_this.cty+2) {
          Tonyu.checkLoop();
          _this.board.y+=_this.getSlideAmount(_this.board.y,_this.cty,0.2);
          t++;
          _this.update();
          
        }
        _this.board.y=_this.cty;
        Tonyu.globals.$Scene=0;
      },
      fiber$SceneFly :function _trc_GameMain_f_SceneFly(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var cnt;
        var velocitys;
        var ty;
        var dices;
        var i;
        var vx;
        var vy;
        var t;
        
        Tonyu.globals.$sound.playSE(Tonyu.globals.$se_shoot08,80);
        _this.all(Tonyu.classes.user.DiceFly).die();
        cnt = _this.board.StartFly(_this.selectCol);
        
        _this.board.StartFall();
        Tonyu.globals.$RotateFlyDiceCnt=0;
        velocitys = [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20];
        
        ty = Tonyu.globals.$screenHeight*2;
        
        dices = [];
        
        i = 0;
        for (; i<cnt ; i++) {
          Tonyu.checkLoop();
          {
            vx = (velocitys.splice(_this.rnd(velocitys.length),1)[0]-10)/2;
            
            vy = (velocitys.splice(_this.rnd(velocitys.length),1)[0]-10)/2;
            
            dices.push(new Tonyu.classes.user.DiceFly({parent: _this.board,x: _this.rnd(Tonyu.globals.$screenWidth),y: _this.rnd(Tonyu.globals.$screenHeight)-ty,heightY: - ty,vx: vx,vy: vy,value: _this.rnd(6)+1}));
          }
        }
        
        _thread.enter(function _trc_GameMain_ent_SceneFly(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (!(Tonyu.globals.$RotateFlyDiceCnt>0)) { __pc=4     ; break; }
              _this.fiber$getSlideAmount(_thread, _this.board.y, ty, 0.1);
              __pc=2;return;
            case 2:
              _this.board.y+=_thread.retVal;
              
              _this.fiber$update(_thread);
              __pc=3;return;
            case 3:
              
              __pc=1;break;
            case 4     :
              
              t = 0;
              
              _this.cty=Tonyu.globals.$screenHeight/2;
              _this.board.EndFly(_this.selectCol,dices);
            case 5:
              if (!(_this.board.y>=_this.cty+2)) { __pc=8     ; break; }
              _this.fiber$getSlideAmount(_thread, _this.board.y, _this.cty, 0.2);
              __pc=6;return;
            case 6:
              _this.board.y+=_thread.retVal;
              
              t++;
              _this.fiber$update(_thread);
              __pc=7;return;
            case 7:
              
              __pc=5;break;
            case 8     :
              
              _this.board.y=_this.cty;
              Tonyu.globals.$Scene=0;
              _thread.exit(_this);return;
            }
          }
        });
      },
      PowerScore :function _trc_GameMain_PowerScore(power) {
        "use strict";
        var _this=this;
        
        _this.scoreLabel.text="(2 + "+power+" * "+power+" * "+power+") * "+Tonyu.globals.$combo+" * "+Tonyu.globals.$combo;
        Tonyu.globals.$Score+=(power*power*power+2)*Tonyu.globals.$combo*Tonyu.globals.$combo;
      },
      fiber$PowerScore :function _trc_GameMain_f_PowerScore(_thread,power) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.scoreLabel.text="(2 + "+power+" * "+power+" * "+power+") * "+Tonyu.globals.$combo+" * "+Tonyu.globals.$combo;
        Tonyu.globals.$Score+=(power*power*power+2)*Tonyu.globals.$combo*Tonyu.globals.$combo;
        
        _thread.retVal=_this;return;
      },
      getSlideAmount :function _trc_GameMain_getSlideAmount(orig,target,ratio) {
        "use strict";
        var _this=this;
        var diff;
        
        ratio=ratio<=1?ratio:1;
        diff = target-orig;
        
        if (_this.abs(diff)>0.1) {
          return diff*ratio;
          
        } else {
          return diff;
          
        }
      },
      fiber$getSlideAmount :function _trc_GameMain_f_getSlideAmount(_thread,orig,target,ratio) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var diff;
        
        ratio=ratio<=1?ratio:1;
        diff = target-orig;
        
        if (_this.abs(diff)>0.1) {
          _thread.retVal=diff*ratio;return;
          
          
        } else {
          _thread.retVal=diff;return;
          
          
        }
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"SceneFall":{"nowait":false},"SceneBoard":{"nowait":false},"SceneFly":{"nowait":false},"PowerScore":{"nowait":false},"getSlideAmount":{"nowait":false}},"fields":{"board":{},"cty":{},"scoreLabel":{},"desc":{},"desc2":{},"nextIsFly":{},"selectCol":{},"selectRow":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Main',
  shortName: 'Main',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Main_main() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$Screen.setBGColor("#333");
        Tonyu.globals.$Screen.resize(600,600);
        Tonyu.globals.$Score=0;
        Tonyu.globals.$UI=new Tonyu.classes.user.UI();
        Tonyu.globals.$twBtn=new Tonyu.classes.kernel.Button({top: Tonyu.globals.$screenHeight-60,height: 40,text: "tweet",onClick: (function anonymous_155() {
          
          Tonyu.globals.$WebPage.openShareTweet("5656dice score: "+Tonyu.globals.$Score+" #ahoge");
        })});
        new Tonyu.classes.user.GameMain();
      },
      fiber$main :function _trc_Main_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$Screen.setBGColor("#333");
        Tonyu.globals.$Screen.resize(600,600);
        Tonyu.globals.$Score=0;
        Tonyu.globals.$UI=new Tonyu.classes.user.UI();
        Tonyu.globals.$twBtn=new Tonyu.classes.kernel.Button({top: Tonyu.globals.$screenHeight-60,height: 40,text: "tweet",onClick: (function anonymous_155() {
          
          Tonyu.globals.$WebPage.openShareTweet("5656dice score: "+Tonyu.globals.$Score+" #ahoge");
        })});
        new Tonyu.classes.user.GameMain();
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.UI',
  shortName: 'UI',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_UI_main() {
        "use strict";
        var _this=this;
        
      },
      fiber$main :function _trc_UI_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.retVal=_this;return;
      },
      Text :function _trc_UI_Text(o) {
        "use strict";
        var _this=this;
        var ctx;
        var x;
        var y;
        var text;
        var textSize;
        var textObj;
        
        ctx = o.ctx;
        
        ctx.save();
        x = o.x!=null?o.x:0;
        
        y = o.y!=null?o.y:0;
        
        text = o.text;
        
        ctx.textBaseline=o.textBaseline||"top";
        ctx.lineWidth=o.lineWidth!=null?o.lineWidth:2;
        textSize = o.size!=null?o.size:28;
        
        ctx.font=textSize+"px sans-serif";
        textObj = ctx.measureText(text);
        
        if (o.align=="center") {
          x=x-textObj.width/2;
          
        }
        ctx.strokeStyle=o.strokeStyle||o.alpha!=null?"rgba(0,0,0,"+o.alpha/255+")":"black";
        ctx.strokeText(text,x,y);
        ctx.fillStyle=o.fillStyle||o.color||"white";
        ctx.fillText(text,x,y);
        ctx.restore();
        return textObj;
      },
      fiber$Text :function _trc_UI_f_Text(_thread,o) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var ctx;
        var x;
        var y;
        var text;
        var textSize;
        var textObj;
        
        ctx = o.ctx;
        
        ctx.save();
        x = o.x!=null?o.x:0;
        
        y = o.y!=null?o.y:0;
        
        text = o.text;
        
        ctx.textBaseline=o.textBaseline||"top";
        ctx.lineWidth=o.lineWidth!=null?o.lineWidth:2;
        textSize = o.size!=null?o.size:28;
        
        ctx.font=textSize+"px sans-serif";
        textObj = ctx.measureText(text);
        
        if (o.align=="center") {
          x=x-textObj.width/2;
          
        }
        ctx.strokeStyle=o.strokeStyle||o.alpha!=null?"rgba(0,0,0,"+o.alpha/255+")":"black";
        ctx.strokeText(text,x,y);
        ctx.fillStyle=o.fillStyle||o.color||"white";
        ctx.fillText(text,x,y);
        ctx.restore();
        _thread.retVal=textObj;return;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"Text":{"nowait":false}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.Fx565656',
  shortName: 'Fx565656',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Fx565656_main() {
        "use strict";
        var _this=this;
        
        _this.radius=_this.radius?_this.radius:32;
        _this.fillStyle="#fff";
        _this.scaleX=4;
        _this.zOrder=- 9;
        _this.t = 180;
        
        _this.maxt = _this.t;
        
        _this.color = "#fff";
        
        Tonyu.globals.$sound.playSE(Tonyu.globals.$se_up,128);
        while (_this.t) {
          Tonyu.checkLoop();
          if (_this.scaleX>1) {
            _this.scaleX*=0.97;
            
          } else {
            _this.scaleX=1;
            
          }
          _this.t--;
          _this.update();
          
        }
        while (_this.alpha>0) {
          Tonyu.checkLoop();
          _this.alpha-=4;
          _this.update();
          
        }
        _this.die();
      },
      fiber$main :function _trc_Fx565656_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.radius=_this.radius?_this.radius:32;
        _this.fillStyle="#fff";
        _this.scaleX=4;
        _this.zOrder=- 9;
        _this.t = 180;
        
        _this.maxt = _this.t;
        
        _this.color = "#fff";
        
        Tonyu.globals.$sound.playSE(Tonyu.globals.$se_up,128);
        
        _thread.enter(function _trc_Fx565656_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (!(_this.t)) { __pc=3     ; break; }
              if (_this.scaleX>1) {
                _this.scaleX*=0.97;
                
              } else {
                _this.scaleX=1;
                
              }
              _this.t--;
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
            case 4:
              if (!(_this.alpha>0)) { __pc=6     ; break; }
              _this.alpha-=4;
              _this.fiber$update(_thread);
              __pc=5;return;
            case 5:
              
              __pc=4;break;
            case 6     :
              
              _this.die();
              _thread.exit(_this);return;
            }
          }
        });
      },
      draw :function _trc_Fx565656_draw(ctx) {
        "use strict";
        var _this=this;
        var y;
        var x;
        var textObj;
        
        ctx.save();
        y = _this.y;
        
        x = _this.x;
        
        _this.color=_this.rnd(2)==0?"rgba(255,255,0,"+_this.alpha/255+")":"rgba(255,255,255,"+_this.alpha/255+")";
        textObj = Tonyu.globals.$UI.Text({ctx: ctx,x: x,y: y,text: "565656",size: 32*_this.scaleX,textBaseline: "center",align: "center",color: Tonyu.bindFunc(_this,_this.color),alpha: _this.alpha});
        
        ctx.restore();
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"draw":{"nowait":true}},"fields":{"t":{},"maxt":{},"color":{}}}
});

//# sourceMappingURL=concat.js.map